#include "dllcore.h"


//////// Bot->DLL ////////

BotEvent makeInit(CALL_COMMAND c, CALL_PLIST p, CALL_FLIST f)
{
	BotEvent event;

	event.code = EVENT_Init;

	event.p[0] = (void*)((CORE_MAJOR_VERSION << 16) | (CORE_MINOR_VERSION));
	event.p[1] = c;
	event.p[2] = p;
	event.p[3] = f;

	return event;
}

BotEvent makeTick()
{
	BotEvent event;

	event.code = EVENT_Tick;

	return event;
}

BotEvent makeArenaEnter(char *name, Player *me)
{
	BotEvent event;

	event.code = EVENT_ArenaEnter;

	event.p[0] = name;
	event.p[1] = me;

	return event;
}

BotEvent makeArenaSettings(arenaSettings *settings)
{
	BotEvent event;

	event.code = EVENT_ArenaSettings;

	event.p[0] = settings;

	return event;
}


BotEvent makeArenaLeave()
{
	BotEvent event;

	event.code = EVENT_ArenaLeave;

	return event;
}

BotEvent makeArenaListEntry(char *name, bool current, int population)
{
	BotEvent event;

	event.code = EVENT_ArenaListEntry;

	event.p[0] = name;
	event.p[1] = *(void**)&current;
	event.p[2] = *(void**)&population;

	return event;
}

BotEvent makeArenaListEnd(char *name, bool current, int population)
{
	BotEvent event;

	event.code = EVENT_ArenaListEnd;

	event.p[0] = name;
	event.p[1] = *(void**)&current;
	event.p[2] = *(void**)&population;

	return event;
}

BotEvent makeCreateTurret(Player *turreter, Player *turretee)
{
	BotEvent event;

	event.code = EVENT_CreateTurret;

	event.p[0] = turreter;
	event.p[1] = turretee;

	return event;
}

BotEvent makeDeleteTurret(Player *turreter, Player *turretee)
{
	BotEvent event;

	event.code = EVENT_DeleteTurret;

	event.p[0] = turreter;
	event.p[1] = turretee;

	return event;
}

BotEvent makePlayerEntering(Player *p)
{
	BotEvent event;

	event.code = EVENT_PlayerEntering;

	event.p[0] = p;

	return event;
}

BotEvent makePlayerMove(Player *p)
{
	BotEvent event;

	event.code = EVENT_PlayerMove;

	event.p[0] = p;

	return event;
}

BotEvent makePlayerDeath(Player *p, Player *k)
{
	BotEvent event;

	event.code = EVENT_PlayerDeath;

	event.p[0] = p;
	event.p[1] = k;

	return event;
}

BotEvent makePlayerPrize(Player *p, int prize)
{
	BotEvent event;

	event.code = EVENT_PlayerPrize;

	event.p[0] = p;
	event.p[1] = *(void**)&prize;

	return event;
}

BotEvent makePlayerScore(Player *p)
{
	BotEvent event;

	event.code = EVENT_PlayerScore;

	event.p[0] = p;

	return event;
}

BotEvent makePlayerShip(Player *p)
{
	BotEvent event;

	event.code = EVENT_PlayerShip;

	event.p[0] = p;

	return event;
}

BotEvent makePlayerSpec(Player *p)
{
	BotEvent event;

	event.code = EVENT_PlayerSpec;

	event.p[0] = p;

	return event;
}

BotEvent makePlayerTeam(Player *p, int old)
{
	BotEvent event;

	event.code = EVENT_PlayerTeam;

	event.p[0] = p;
	event.p[1] = (void*)old;

	return event;
}

BotEvent makePlayerLeaving(Player *p)
{
	BotEvent event;

	event.code = EVENT_PlayerLeaving;

	event.p[0] = p;

	return event;
}

BotEvent makeFlagGrab(Player *p, Flag *f)
{
	BotEvent event;

	event.code = EVENT_FlagGrab;

	event.p[0] = p;
	event.p[1] = f;

	return event;
}

BotEvent makeFlagDrop(Player *p)
{
	BotEvent event;

	event.code = EVENT_FlagDrop;

	event.p[0] = p;

	return event;
}

BotEvent makeFlagMove(Flag *f)
{
	BotEvent event;

	event.code = EVENT_FlagMove;

	event.p[0] = *(void**)&f;

	return event;
}

BotEvent makeFlagVictory(int team, int points)
{
	BotEvent event;

	event.code = EVENT_FlagVictory;

	event.p[0] = *(void**)&team;
	event.p[1] = *(void**)&points;

	return event;
}

BotEvent makeFlagReward(int team, int points)
{
	BotEvent event;

	event.code = EVENT_FlagReward;

	event.p[0] = *(void**)&team;
	event.p[1] = *(void**)&points;

	return event;
}

BotEvent makeTimedGameOver(Player *p1, Player *p2, Player *p3, Player *p4, Player *p5)
{
	BotEvent event;

	event.code = EVENT_TimedGameOver;

	event.p[0] = p1;
	event.p[1] = p2;
	event.p[2] = p3;
	event.p[3] = p4;
	event.p[4] = p5;

	return event;
}

BotEvent makeSoccerGoal(int team, int points)
{
	BotEvent event;

	event.code = EVENT_SoccerGoal;

	event.p[0] = *(void**)&team;
	event.p[1] = *(void**)&points;

	return event;
}

BotEvent makeFile(char *name)
{
	BotEvent event;

	event.code = EVENT_File;

	event.p[0] = name;

	return event;
}

BotEvent makeChat(int t, int s, Player *p, char *m)
{
	BotEvent event;

	event.code = EVENT_Chat;

	event.p[0] = *(void**)&t;
	event.p[1] = *(void**)&s;
	event.p[2] = p;
	event.p[3] = m;

	return event;
}

BotEvent makeLocalHelp(Player *p, Command *c)
{
	BotEvent event;

	event.code = EVENT_LocalHelp;

	event.p[0] = p;
	event.p[1] = c;

	return event;
}

BotEvent makeLocalCommand(Player *p, Command *c)
{
	BotEvent event;

	event.code = EVENT_LocalCommand;

	event.p[0] = p;
	event.p[1] = c;

	return event;
}

BotEvent makeRemoteHelp(char *p, Command *c, int o)
{
	BotEvent event;

	event.code = EVENT_RemoteHelp;

	event.p[0] = p;
	event.p[1] = c;
	event.p[2] = *(void**)&o;

	return event;
}

BotEvent makeRemoteCommand(char *p, Command *c, int o)
{
	BotEvent event;

	event.code = EVENT_RemoteCommand;

	event.p[0] = p;
	event.p[1] = c;
	event.p[2] = *(void**)&o;

	return event;
}

BotEvent makeBallMove(PBall *pb)
{
	BotEvent event;

	event.code = EVENT_BallMove;

	event.p[0] = pb;

	return event;
}

BotEvent makeTerm()
{
	BotEvent event;

	event.code = EVENT_Term;

	return event;
}


//////// DLL->Bot ////////

BotEvent makeEcho(char *m)
{
	BotEvent event;

	event.code = EVENT_Echo;

	event.p[0] = m;

	return event;
}

BotEvent makeSay(int t, int s, int i, char *m)
{
	BotEvent event;

	event.code = EVENT_Say;

	event.p[0] = *(void**)&t;
	event.p[1] = *(void**)&s;
	event.p[2] = *(void**)&i;
	event.p[3] = m;

	return event;
}

BotEvent makeShip(int s)
{
	BotEvent event;

	event.code = EVENT_Ship;

	event.p[0] = *(void**)&s;

	return event;
}

BotEvent makeGrabFlag(int f)
{
	BotEvent event;

	event.code = EVENT_GrabFlag;

	event.p[0] = *(void**)&f;

	return event;
}

BotEvent makeSendPosition()
{
	BotEvent event;

	event.code = EVENT_SendPosition;

	return event;
}

BotEvent makeDropFlags()
{
	BotEvent event;

	event.code = EVENT_DropFlags;

	return event;
}

BotEvent makeSpawnBot(char *name, char *password, char *staff, char *arena)
{
	BotEvent event;

	event.code = EVENT_SpawnBot;

	event.p[0] = name;
	event.p[1] = password;
	event.p[2] = staff;
	event.p[3] = arena;

	return event;
}

BotEvent makeChangeArena(char *name)
{
	BotEvent event;

	event.code = EVENT_ChangeArena;

	event.p[0] = name;

	return event;
}

//////// Event Class ////////

BotEvent::BotEvent(BotEvent &b)
{
	code = b.code;

	p[0] = b.p[0];
	p[1] = b.p[1];
	p[2] = b.p[2];
	p[3] = b.p[3];
}

BotEvent::BotEvent()
{
	code = 0;

	p[0] = 0;
	p[1] = 0;
	p[2] = 0;
	p[3] = 0;
}
